'                   
'
'
'
'
'                        Sub-Routines & Functions
'
'                     Written by:  David Stinemetze
'               Explanations of sub-routines and functions
'             can be found in the sub-routines and functions
'
'
'
'
'
'
'
'
'
'
'        FUNCTIONS
'
DECLARE FUNCTION compound! (p!, i!, n!)
' Sample:  print compound (2, 1, 3)  -  solves the compound interest with a
'          principle of 2, interest of 1, and 3 years
DECLARE FUNCTION diceprob$ (s!)
' Sample:  display$ = diceprob$(12)  -  solves the probability of getting the
'          sum of rolling two dice
DECLARE FUNCTION discriminant! (a!, b!, c!)
' Sample:  print discriminant (-1, -4, 4)  -  solves the discriminate of
'          -x^2-4x+4=0
DECLARE FUNCTION ex$ (x)
' Sample:  print ex$ (3)  -  solves e ^ 3 power when e is approx 2.71828182846
DECLARE FUNCTION factor$ (n!)
' Sample:   PRINT factor$(100)  -  displays all the factors of 100
DECLARE FUNCTION factorial# (x#)
' Sample:   PRINT factorial#(4)  - gives the factorial of 4
DECLARE FUNCTION fPart! (x!)
' Sample:   print fPart(3.14159) - displays fraction part of
'           3.14159 which is .14159
DECLARE FUNCTION geomean! (a!, b!)
' Sample:   PRINT geomean (9, 16)  -  gives the geometric mean value of x for
'           9/x=x/16
DECLARE FUNCTION gpa! (numclass!, one!, two!, three!, four!, five!, six!, seven!, eight!, nine!, ten!)
' Sample:  print gpa (8, 98, 92, 87, 92, 91, 82, 72, 99, 0, 0)  -  solves
'          the gpa of 8 classes
DECLARE FUNCTION heron$ (a!, b!, c!)
' Sample:   PRINT heron$(6, 8, 10)  -  finds the area of a triangle with sides
'           of 6, 8, and 10
DECLARE FUNCTION lawcos$ (a!, b!, c!)
' Sample:   PRINT lawcos$(6, 8, 90)  -  uses law of cosines to find the value
'           of side c with side a = 6, side b = 8, and angle C = 90
DECLARE FUNCTION line$ (x!, x$)
'  Sample:   PRINT line$(7, "abc123")  -  centers abc123 on line 7
DECLARE FUNCTION Log10! (x!)
'  Sample:   x = Log10(y)  -  stores the logorithim on base 10 and stores it
'            as the variable x
DECLARE FUNCTION ln (x!)
' Sample:    print ln (20.0855369232)  -  Solves the logarithim on a base of
'            e  -  approx: 2.71828182846
DECLARE FUNCTION midpoint$ (x1!, x2!, y1!, y2!)
' Sample:  print midpoint$ (1, 2, 7, 2)  -  gives the midpoint (x1,y1)-(x2,y2)
DECLARE FUNCTION NumOccur! (var$, char$)
' Sample:  print NumOccur("abc/def/ghi/jkl/mno/pqr/stu/vwx/yz", "/")  -  displays
'          amount of times / occurs in "abc/def/ghi/jkl/mno/pqr/stu/vwx/yz"
DECLARE FUNCTION primecheck! (p!)
' Sample:   y = primecheck(105)  -  checks to see if 105 is prime:  1-prime
'           2-not prime
DECLARE FUNCTION primefactor$ (n!)
' Sample:   PRINT primefactor$(105)  -  displays the prime factors of 105
DECLARE FUNCTION prodroot! (a!, c!)
' Sample:  print prodroot (2, 3)  -  gives the product of the roots of the
'          quadratic equation 2x^2+bx+3=0
DECLARE FUNCTION pt$ (a!, b!)
' Sample:   PRINT pt$(6, 8)  -  solves pythagoreans thereom when a=6 and b=8
DECLARE FUNCTION raddeg (x!)
' Sample:   PRINT raddeg(7)  -  Converts 7 in radians to degrees
DECLARE FUNCTION replace$ (var$, char$, repchar$, sensitivity!)
' Sample:   PRINT replace$ ("mmmMMMmMmMMMMmmmmMMmMMmMMMmmMMmMMMm", "m", "-", 1)
'           - replaces all occurences of "m" with "-" Set for case-sensitivity
'             1 in last position marks case-sensitive.  as 0 makes it not!
DECLARE FUNCTION round# (a#, b#)
' Sample:   PRINT round#(3.141592653589, 5) takes 3.141592653589 out to 5
'           decimal places which is 3.14159
DECLARE FUNCTION series! (interval!, x!, y!)
' Sample:   print series (2, 2, 10)  -  adds  2 + 4 + ... + 10 with 2 as the
'           interval, 2, as the lowest number, and 10 as the highest number
DECLARE FUNCTION simple! (p!, i!, n!)
' Sample:  print simple (2, 3, 1)  -  Solves the simple interest with a
'          principle of 2, interest of 3, and 1 year
DECLARE FUNCTION slope! (x1!, x2!, y1!, y2!)
' Sample:  PRINT slope (2, 3, 6, 8)  -  Solves the slope of (2,3)-(6,8)
DECLARE FUNCTION splitvar$ (var$, char$, varnum!)
' Sample:  PRINT splitvar$ ("abc/def/ghi/jkl/mno/pqr/stu/vwx/yz", "/", 3)
'          - returns the 3rd variable after splitting
'            "abc/def/ghi/jkl/mno/pqr/stu/vwx/yz" by "/"  = displays "ghi"
DECLARE FUNCTION sumroot! (a!, b!)
' Sample:  PRINT sumroot (3, 2)  -  Solves the sum of the root of the
'          quadratic equation  3x^2+2x+c=0
DECLARE FUNCTION tri (x)
' Sample:   PRINT tri(15)  -  gives the triangular # of 15
DECLARE FUNCTION xroot (x!, rad!)
' Sample:   PRINT xroot(3, 64)  -  finds the cube root of 64
DECLARE FUNCTION yx$ (y!, x!)
' Sample:   PRINT yx$(2,10)  -  displays 2 ^ 10 in scientific notation
'
'   Sub-Routines
'            
DECLARE SUB cline (x!, y!)
' Sample:   cline (1, 4)  -  clears lines 1 - 4
DECLARE SUB copy (file$, newfile$)
' Sample:   copy "stuff.bak", "stuff1.bak"
DECLARE SUB decfrac (n#)
' Sample:   decfrac .37  -  converts .37 to 37/100
DECLARE SUB dos (ctitle$, ccommand$)
' Sample:   dos "DS-DOS", "DS-DOS v1.0:    David Stinemetze - davidstinemetze@rocketmail.com"  -  runs a DOS shell
DECLARE SUB freeze (x!)
' Sample:   freeze .375  -  pauses for 3/8 of a second
DECLARE SUB rename (file$, newfile$)
' Sample:   rename "stuff.mon", "stuff1.mon"  -  Renames stuff.mon
'           to stuff1.mon
DECLARE SUB primes (p!, b!, value!)
' Sample:   primes 1, 1000, 1  -  displays all primes between 1 and 1000 and then
'           tells you how many primes there are between 1 and 1000
DECLARE SUB primetwins (p!, b!)
' Sample:   primetwins 10, 100  -  displays all prime twins between 10 and 100
DECLARE SUB pythagtrip (a!, b!)
' Sample:   pythagtrip 1, 100 - displays all pythagoreans triplets from 1 to 100
DECLARE SUB quadratic (a!, b!, c!)
' Sample:   quadratic 1, 3, -4  -  Solves the quadratic equation
'           x^2+3x-4=0
DECLARE SUB shellsort (sort$(), numOfElements)
' Sample:
' dim a$(1 to 10)
' for n = 1 to 10
'  a$(n) = str$(int(rnd * 100)+1)
'  print a$(n);
' next
' shellsort a$(), 10
' for n = 1 to 10
'  print a$(n)
' next
' -takes array a$ and sorts it based on the 10 elements in the array.
DECLARE SUB text (d$, s!)
' Sample:   text "David Stinemetze", 2  -  displays David Stinemetze
'           in big text
DECLARE SUB title (program$, name$, company$, email$, url$, other$)
' Sample:   title "David's Sub Routine Program", "David Stinemetze", "ShaniaRules.com", "shaniarules@shaniarules.com", "http://www.shaniarules.com", "Press any key..."
'           -  displays program title, author, company, email, url and any
'           other useful info.
DECLARE SUB word (wordval$)
'Sample:   word "STUFF"  -  displays ascii value of STUFF
CLS
dos "DS-DOS", "DS-DOS v1.0:     David Stinemetze - davidstinemetze@rocketmail.com"

SUB cline (x, y)
'This function clears all the text on the starting line(x) to line(y)
'Written by:  David Stinemetze
 IF y < x THEN SWAP x, y
 FOR k = x TO y
  LOCATE k, 1: PRINT "                                                                                "
 NEXT
END SUB

FUNCTION compound (p, i, n)
'This function calculates compound interest
'Written by:  David Stinemetze
 compound = p * (1 + i) ^ n
END FUNCTION

SUB copy (file$, newfile$)
' Copies file$ to newfile$
' Written by:  David Stinemetze
 SHELL "copy " + file$ + " " + newfile$
END SUB

SUB decfrac (n#)
'This Sub-Routine converts decimals to fractions
'Written by:  David Stinemetze
 d# = 0
 DO
  d# = d# + 1
  IF fPart(round(n# * d#, 10)) = 0 THEN EXIT DO
 LOOP
 n# = n# * d#
 PRINT INT(n#); "/"; INT(d#)
 PRINT n# / d#
END SUB

FUNCTION diceprob$ (s)
 'This function calculates the probability of getting the inputed sum when
 'rolling to normal dice
 'Written by:  David Stinemetze
 value = (6 - ABS(s - 7))
 denom = 36
 zero = 0
 DO
  reduced = 0
  SELECT CASE zero
   CASE value / 2 - INT(value / 2)
    PRINT 2
    value = value / 2
    denom = denom / 2
   CASE value / 3 - INT(value / 3)
    value = value / 3
    denom = denom / 3
   CASE value / 4 - INT(value / 4)
    value = value / 4
    denom = denom / 4
   CASE value / 6 - INT(value / 6)
    value = value / 6
    denom = denom / 6
   CASE value / 9 - INT(value / 9)
    value = value / 9
    denom = denom / 9
   CASE value / 12 - INT(value / 12)
    value = value / 12
    denom = denom / 12
   CASE NOT reduced
    EXIT DO
   CASE ELSE
    value = value
    denom = denom
    reduced = 1
  END SELECT
 LOOP UNTIL reduced = 1
 diceprob$ = STR$(value) + "/" + STR$(denom)
END FUNCTION

FUNCTION discriminant (a, b, c)
' This function calculates the discriminant of a quadratic equation
' Written by:  David Stinemetze
 discriminant = b ^ 2 - 4 * a * c
END FUNCTION

SUB dos (ctitle$, ccommand$)
PRINT

'################################################
'Thanks to Matthew R. Usner for providing the
'following source code...
'mattu@ix.netcom.com or 75342.1777@compuserve.com.

SHELL "CD >CD.TXT"
 f% = FREEFILE
 OPEN "I", f%, "CD.TXT"
 LINE INPUT #f%, CD$
 CLOSE f%

 KILL "CD.TXT"
dir$ = CD$
'################################################

                                        
PRINT ctitle$
DO
 PRINT
 PRINT "Type EXIT to leave "; ctitle$; " or HELP to see the command list"
 PRINT dir$; ">";
 INPUT "", c$
 c$ = LCASE$(c$)
 SELECT CASE c$
  CASE ""
  CASE "help"
   PRINT "----------------"
   PRINT "- Command List -"
   PRINT "----------------"
   PRINT "dir             shows files within a directory."
   PRINT "                parameter list:"
   PRINT "                      /w - shows all files in an"
   PRINT "                           organized form showing"
   PRINT "                           will 4 files in one row"
   PRINT "                      /s - shows all files in cur-"
   PRINT "                           rent directory and all"
   PRINT "                           sub directories within"
   PRINT "                           that directory"
   PRINT "                      /p - pauses after screen is full"
   PRINT "                file.ext - will search for a certain"
   PRINT "                           file to see if it exists"
   PRINT "                           use * for wildcards"
   PRINT "cls             clears the screen"
   PRINT "command         shows about information "
   PRINT "help            displays this command list"
   PRINT "exit            exit "; ctitle$
   PRINT "       *** For More Assistance, Please See A DOS Book ***"
  CASE "exit"
   END
  CASE "C:\command"
   PRINT ccommand$
  CASE "C:\command.com"
   PRINT ccommand$
  CASE ELSE
   IF INSTR(c$, "command") THEN
    FOR k = 1 TO LEN(c$)
     IF LEFT$(c$, 7) = "command" THEN
      PRINT ccommand$
      EXIT FOR
     ELSE
      SHELL "c$"
      EXIT FOR
     END IF
    NEXT
   ELSE
    SHELL c$
   END IF
 END SELECT
LOOP UNTIL c$ = "exit"
SYSTEM

END SUB

FUNCTION ex$ (x!)
' This function solves e ^ x when e is 2.71828182846
' Written by:  David Stinemetze
 ex$ = yx$(2.71828182846#, x)
END FUNCTION

FUNCTION factor$ (n)
' This program prints all of a numbers factors
' Written by:  David Stinemetze
 fact$ = ""
 FOR k = 1 TO n
  IF n / k - INT(n / k) = 0 THEN fact$ = fact$ + " " + STR$(k)
 NEXT
 factor$ = fact$
END FUNCTION

FUNCTION factorial# (x#)
' This function calculates the factorial of an inputed number
' Written by:  David Stinemetze
factval# = 1
 FOR f# = 2 TO x#
  factval# = factval# * f#
 NEXT
 factorial# = factval#
END FUNCTION

FUNCTION fPart (x)
'This function gives you the fraction part of x
'Written by:  David Stinemetze
 fPart = ABS(INT(x) - x)
END FUNCTION

SUB freeze (x)
 TIMER ON
 start = TIMER
 DO
  x$ = INKEY$
 LOOP UNTIL ABS(TIMER - start) >= x OR x$ <> ""
END SUB

FUNCTION geomean (a, b)
 'This FUNCTION solves the geometric mean of inputed a and b
 'Written by:  David Stinemetze
 geomean = SQR(a * b)
END FUNCTION

FUNCTION gpa (numclass, one, two, three, four, five, six, seven, eight, nine, ten)
'This program calculates your gpa for up to 10 classes.  numclass is the
'# of classes.  put 0 for all extra classes
'Written by:  David Stinemetze
 SELECT CASE numclass
  CASE 1
   gpa = one / 25
  CASE 2
   gpa = (one + two) / 50
  CASE 3
   gpa = (one + two + three) / 75
  CASE 4
   gpa = (one + two + three + four) / 100
  CASE 5
   gpa = (one + two + three + four + five) / 125
  CASE 6
   gpa = (one + two + three + four + five + six) / 150
  CASE 7
   gpa = (one + two + three + four + five + six + seven) / 175
  CASE 8
   gpa = (one + two + three + four + five + six + seven + eight) / 200
  CASE 9
   gpa = (one + two + three + four + five + six + seven + eight + nine) / 225
  CASE 10
   gpa = (one + two + three + four + five + six + seven + eight + nine + ten) / 250
 END SELECT
END FUNCTION

FUNCTION heron$ (a, b, c)
' This program uses heron's formula to calculate the area of a triangle
' Written by:  David Stinemetze
 s = (a + b + c) / 2
 heron$ = STR$(SQR(s * (s - a) * (s - b) * (s - c)))
END FUNCTION

FUNCTION lawcos$ (a, b, c)
' This program uses the Law of Cosines using side a, side b, and angle C
' to calculate the length of side C
' Written By:  David Stinemetze
 cosC = COS(c)
 cosC = raddeg(cosC)
 lawcos$ = STR$(SQR(a ^ 2 + b ^ 2 - 2 * a * b * cosC))
END FUNCTION

FUNCTION line$ (x, x$)
' This centers text on the line inputed by the user
' If you enter a value for the line of more than 24
' then the program will keep subtracting 24 until it
' has reached a number between 0 and 24.  If you put
' a number less than 0, it will add 24 to the number
' until it is between 0 and 24
' Written By:  David Stinemetze
 DO
  SELECT CASE x
   CASE IS > 24
    x = x - 24
   CASE IS < 0
    x = x + 24
  END SELECT
 LOOP UNTIL x <= 24 AND x >= 1
 LOCATE x, 41 - LEN(x$) / 2: PRINT x$;
END FUNCTION

FUNCTION ln (x!)
 ln = LOG(x!)
END FUNCTION

FUNCTION Log10 (x) STATIC
' This program calculates a base-10 logarithim
' Written By:  Microsoft Corporation
 Log10 = LOG(x) / LOG(10#)
END FUNCTION

FUNCTION midpoint$ (x1, x2, y1, y2)
'This calculates the midpoint of inputed coordinates
'Written by: David Stinemetze
 midpoint$ = CHR$(40) + STR$((x1 + x2) / 2) + CHR$(44) + STR$((y1 + y2) / 2) + CHR$(41)
END FUNCTION

FUNCTION NumOccur (var$, char$)
 ' This function tells you how many times char$ is found in variable var$
 ' Written by:  David Stinemetze
 n = 1
 occur = 0
 DO WHILE n <= LEN(var$)
  IF MID$(var$, n, LEN(char$)) = char$ THEN occur = occur + 1
  n = n + 1
 LOOP
 NumOccur = occur
END FUNCTION

FUNCTION primecheck (p)
' This takes a number, and checks if it is prime
' Written By:  David Stinemetze
 primecheck = 1
 d = 3
 DO
  IF p / d - INT(p / d) = 0 THEN primecheck = 0
  d = d + 2
 LOOP UNTIL d - 2 > SQR(p)
END FUNCTION

 FUNCTION primefactor$ (n)
' This program displays all prime factor of the number inputed
' Written By:  David Stinemetze
 FOR k = 2 TO n - 1
  IF n / k - INT(n / k) = 0 THEN
   x = primecheck(k)
   SELECT CASE x
    CASE 0
    CASE 1: pfactor$ = pfactor$ + " " + STR$(k)
   END SELECT
  END IF
 NEXT
 primefactor$ = pfactor$
END FUNCTION

SUB primes (p, b, value)
' This displays all primes between p and b
' Written by:  David Stinemetze
porg = p
IF p > b THEN SWAP p, b
DO
 IF primecheck(p) = 0 THEN p = p + 1
LOOP UNTIL primecheck(p) = 1
DO
  total = total + 1
  SELECT CASE value
   CASE 1
    PRINT p;
   CASE 0
    PRINT p
   CASE ELSE
    PRINT "INVALID VALUE"
    EXIT SUB
  END SELECT
  p = p + 2
  d = 3
  DO
   DO
    IF p / d - INT(p / d) = 0 THEN
     p = p + 2
     d = 3
     EXIT DO
     END IF
     d = d + 2
    LOOP UNTIL d > SQR(p)
  LOOP UNTIL d > SQR(p)
 LOOP UNTIL p > b OR INKEY$ <> ""
 PRINT
 PRINT
 PRINT "There are"; total; "primes between"; porg; "and"; b
END SUB

SUB primetwins (p!, b!)
'This sub routine displays all the prime twins between the inputed p and b
'Written by:  David Stinemetze
d = 3
DO
 IF primecheck(p) = 1 THEN
  IF primecheck(p + 2) = 1 THEN
   PRINT p; p + 2
  END IF
 END IF
 p = p + 2
LOOP UNTIL p > b - 2
END SUB

FUNCTION prodroot (a, c)
 'This function calculates the product of the roots in a quadratic equation
 'Written by:  David Stinemetze
 prodroot = c / a
END FUNCTION

FUNCTION pt$ (a, b)
' This program runs Pythagorean Theorem by using the values of a and b
' Written By:  David Stinemetze
 pt$ = STR$(SQR(a ^ 2 + b ^ 2))
END FUNCTION

SUB pythagtrip (a, b)
' This sub routine displays all pythagorean triplets inputed between a and b
' Written by:  David Stinemetze
total = 0
 IF a < 3 THEN
  aval = a
  a = 3
 ELSE
  aval = a
 END IF
 IF b <= 0 THEN a = 1
 IF a > b THEN SWAP a, b
 FOR x = a TO b
  FOR y = a TO b
   FOR z = a TO b
    IF z = SQR(INT(x) ^ 2 + INT(y) ^ 2) THEN
     s$ = " " + STR$(x) + " "
     IF INSTR(x$, s$) THEN
      l$ = " " + STR$(y) + " "
      IF INSTR(x$, l$) THEN
       m$ = " " + STR$(y) + " "
       IF INSTR(x$, m$) THEN
       ELSE
        x$ = x$ + " " + STR$(x) + " " + STR$(y) + " " + STR$(z) + " "
        PRINT x; y; z
        total = total + 1
       END IF
      ELSE
       x$ = x$ + " " + STR$(x) + " " + STR$(y) + " " + STR$(z) + " "
       PRINT x; y; z
       total = total + 1
      END IF
     ELSE
      x$ = x$ + " " + STR$(x) + " " + STR$(y) + " " + STR$(z) + " "
      PRINT x; y; z
      total = total + 1
     END IF
    END IF
   NEXT
  NEXT
 NEXT
 PRINT
 PRINT "     "; total; "total pythagorean triplets between"; aval; "to"; b
END SUB

SUB quadratic (a, b, c)
' The program runs the Quadratic Formula based on ax^2+bx+c=0
' Written by:  David Stinemetze
 IF a = 0 THEN PRINT "Error!  Division by Zero"
 IF b ^ 2 - 4 * a * c < 0 THEN
  PRINT "No Solution"
  PRINT "Discriminant ="; b ^ 2 - 4 * a * c
 ELSE
  PRINT "x =" + STR$((-b + SQR(b ^ 2 - 4 * a * c)) / (2 * a)) + " or x = " + STR$((-b - SQR(b ^ 2 - 4 * a * c)) / (2 * a))
 END IF
END SUB

FUNCTION raddeg (x)
' This converts radians -> degress
' Written By:  David Stinemetze
 pi = 3.141592653589#
 raddeg = (x * 180) / pi
END FUNCTION

SUB rename (file$, newfile$)
'This renames file$ to newfile$
'Written by:  David Stinemetze
 SHELL "rename " + file$ + " " + newfile$
END SUB

FUNCTION replace$ (var$, char$, repchar$, sensitivity!)
' Replaces all occurences of char$ in var$ with repchar$ based on case-sensitivity
' Written by:  David Stinemetze
 x$ = var$
 IF sensitivity = 0 THEN
   FOR n = 1 TO LEN(var$)
    IF LCASE$(MID$(x$, n, LEN(char$))) = LCASE$(char$) THEN x$ = LEFT$(x$, n - 1) + repchar$ + RIGHT$(x$, LEN(x$) - (n + LEN(char$) - 1))
   NEXT
   replace$ = x$
   
   EXIT FUNCTION
 ELSE
   FOR n = 1 TO LEN(var$)
    IF MID$(x$, n, LEN(char$)) = char$ THEN x$ = LEFT$(x$, n - 1) + repchar$ + RIGHT$(x$, LEN(x$) - (n + LEN(char$) - 1))
   NEXT
   replace$ = x$
   
   EXIT FUNCTION
 END IF
END FUNCTION

FUNCTION round# (a#, b#)
'This function rounds a out to b digits
'Written by:  David Stinemetze
 round# = INT(a# * 10 ^ b#) / (10 ^ b#)
END FUNCTION

FUNCTION series (interval, x, y)
' This gives the sum of x + (x + interval) + (x + 2 * interval) + ... + y
' Written by:  David Stinemetze
 IF x > y THEN SWAP x, y
 series = ((y - x) / interval + 1) * (x + y) / 2
END FUNCTION

SUB shellsort (sort$(), numOfElements)
' Sorts array sort$() based on the number of elements in the array
' Written by:  David Stinemetze
' This is a modification of a Microsoft script for Visual Basic 6.0
span% = numOfElements \ 2
DO WHILE span% > 0
    FOR i% = span% TO numOfElements - 1
        j% = i% - span% + 1
        FOR j% = (i% - span% + 1) TO 1 STEP -span%
            IF sort$(j%) <= sort$(j% + span%) THEN EXIT FOR
            temp$ = sort$(j%)
            sort$(j%) = sort$(j% + span%)
            sort$(j% + span%) = temp$
        NEXT j%
    NEXT i%
    span% = span% \ 2
LOOP

END SUB

FUNCTION simple (p, i, n)
'This calculates simple interest
'Written by:  David Stinemetze
 simple = (n / 12) * p * (i + 1)
END FUNCTION

FUNCTION slope (x1, x2, y1, y2)
'This function calculates the slopes, based on inputed coordinates
'Written by:  David Stinemetze
 slope = (y2 - y1) / (x2 - x1)
END FUNCTION

FUNCTION splitvar$ (var$, char$, varnum)
 t = 0
 r = 1
 n = 1
 DO WHILE n <= LEN(var$)
  IF MID$(var$, n, LEN(char$)) = char$ THEN
   IF t = varnum THEN
    x$ = MID$(var$, r, n - r)
    EXIT DO
   END IF
   t = t + 1
   r = n + LEN(char$)
  END IF
  n = n + 1
 LOOP
 IF varnum = NumOccur(var$, char$) THEN x$ = RIGHT$(var$, n - r)

 splitvar$ = x$
END FUNCTION

FUNCTION sumroot (a, b)
 'This function calculates the sum of the roots of a quadratic equation
 'Written by:  David Stinemetze
 sumroot = -b / a
END FUNCTION

SUB text (d$, s)
'This program takes letters and draws them big...
'Written by:  David Stinemetze
SCREEN 11
x$ = ""
total = 600
number = INT(600 / LEN(d$))
IF INSTR(d$, " ") THEN
 m$ = d$
ELSE
 FOR l = 1 TO LEN(d$)
  x$ = x$ + MID$(d$, l, 1) + " "
 NEXT
 d$ = x$
END IF
FOR k = 1 TO LEN(d$)
 m$ = MID$(d$, k, 1)
 SELECT CASE LCASE$(m$)
  CASE "a"
   LINE (15 * k + 15, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 40, 35 * s - 15)
  CASE "b"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 80, 20 * s - 15)
   LINE (15 * k + total / 80, 20 * s - 15)-(15 * k + total / 40, 27.5 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 80, 35 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 80, 50 * s - 15)
   LINE (15 * k + total / 80, 50 * s - 15)-(15 * k + total / 40, 42.5 * s - 15)
   LINE (15 * k + total / 80, 35 * s - 15)-(15 * k + total / 40, 27.5 * s - 15)
   LINE (15 * k + total / 80, 35 * s - 15)-(15 * k + total / 40, 42.5 * s - 15)
  CASE "c"
   LINE (15 * k + total / 80, 20 * s * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 80, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k, 27.5 * s - 15)-(15 * k, 42.5 * s - 15)
   LINE (15 * k, 27.5 * s - 15)-(15 * k + total / 80, 20 * s - 15)
   LINE (15 * k, 42.5 * s - 15)-(15 * k + total / 80, 50 * s - 15)
  CASE "d"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 80, 20 * s - 15)
   LINE (15 * k + total / 80, 20 * s - 15)-(15 * k + total / 40, 27.5 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 80, 50 * s - 15)
   LINE (15 * k + total / 80, 50 * s - 15)-(15 * k + total / 40, 42.5 * s - 15)
   LINE (15 * k + total / 40, 27.5 * s - 15)-(15 * k + total / 40, 42.5 * s - 15)
  CASE "e"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 80, 35 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "f"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 80, 35 * s - 15)
  CASE "g"
   LINE (15 * k + total / 160, 35 * s - 15)-(15 * k + (3 * total) / 160, 35 * s - 15)
   LINE (15 * k + (3 * total * s - 15) / 160, 35 * s - 15)-(15 * k + total / 40, 40 * s - 15)
   LINE (15 * k + total / 40, 40 * s - 15)-(15 * k + total / 40, 45 * s - 15)
   LINE (15 * k + total / 40, 45 * s - 15)-(15 * k + total * 3 / 160, 50 * s - 15)
   LINE (15 * k + total * 3 / 160, 50 * s - 15)-(15 * k + total / 160, 50 * s - 15)
   LINE (15 * k + total / 160, 50 * s - 15)-(15 * k, 45 * s - 15)
   LINE (15 * k, 45 * s - 15)-(15 * k, 24 * s - 15)
   LINE (15 * k, 24 * s - 15)-(15 * k + total / 160, 20 * s - 15)
   LINE (15 * k + total / 160, 20 * s - 15)-(15 * k + total * 3 / 160, 20 * s - 15)
  CASE "h"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 40, 35 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "i"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 80, 20 * s - 15)-(15 * k + total / 80, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "j"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 80, 20 * s - 15)-(15 * k + total / 80, 50 * s - 15)
   LINE (15 * k, 42.5 * s - 15)-(15 * k + total / 320, 50 * s - 15)
   LINE (15 * k + total / 320, 50 * s - 15)-(15 * k + total / 80, 50 * s - 15)
  CASE "k"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "l"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "m"
   LINE (15 * k, 50 * s - 15)-(15 * k, 20 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 80, 35 * s - 15)
   LINE (15 * k + total / 80, 35 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "n"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k + total / 40, 50 * s - 15)-(15 * k + total / 40, 20 * s - 15)
  CASE "o"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k + total / 40, 50 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k, 20 * s - 15)
  CASE "p"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k + total / 40, 35 * s - 15)
   LINE (15 * k + total / 40, 35 * s - 15)-(15 * k, 35 * s - 15)
  CASE "q"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 60, 20 * s - 15)
   LINE (15 * k + total / 60, 20 * s - 15)-(15 * k + total / 60, 45 * s - 15)
   LINE (15 * k + total / 40, 50 * s - 15)-(15 * k + total / 160, 35 * s - 15)
   LINE (15 * k + total / 60, 45 * s - 15)-(15 * k, 45 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k, 45 * s - 15)
  CASE "r"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k + total / 40, 35 * s - 15)
   LINE (15 * k + total / 40, 35 * s - 15)-(15 * k + total / 80, 35 * s - 15)
   LINE (15 * k + total / 80, 35 * s - 15)-(15 * k + total / 40, 50 * s - 15)
  CASE "s"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k, 20 * s - 15)-(15 * k, 35 * s - 15)
   LINE (15 * k, 35 * s - 15)-(15 * k + total / 40, 35 * s - 15)
   LINE (15 * k + total / 40, 35 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k + total / 40, 50 * s - 15)-(15 * k, 50 * s - 15)
  CASE "t"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 80, 20 * s - 15)-(15 * k + total / 80, 50 * s - 15)
  CASE "u"
   LINE (15 * k, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k + total / 40, 50 * s - 15)-(15 * k + total / 40, 20 * s - 15)
  CASE "v"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 80, 50 * s - 15)
   LINE (15 * k + total / 80, 50 * s - 15)-(15 * k + total / 40, 20 * s - 15)
  CASE "w"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 200, 50 * s - 15)
   LINE (15 * k + total / 200, 50 * s - 15)-(15 * k + 2 * total / 200, 30 * s - 15)
   LINE (15 * k + 2 * total / 200, 30 * s - 15)-(15 * k + 3 * total / 200, 50 * s - 15)
   LINE (15 * k + 3 * total / 200, 50 * s - 15)-(15 * k + 4 * total / 200, 20 * s - 15)
  CASE "x"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 20 * s - 15)
  CASE "y"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 80, 35 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 20 * s - 15)
  CASE "z"
   LINE (15 * k, 20 * s - 15)-(15 * k + total / 40, 20 * s - 15)
   LINE (15 * k + total / 40, 20 * s - 15)-(15 * k, 50 * s - 15)
   LINE (15 * k, 50 * s - 15)-(15 * k + total / 40, 50 * s - 15)
 END SELECT
NEXT
END SUB

SUB title (program$, name$, company$, email$, url$, other$)
'This lets you make a title page, just by inputing variables
'Written by:  David Stinemetze
 CLS
 COLOR 15
 PRINT line$(6, program$)
 COLOR 7
 PRINT line$(9, "by")
 PRINT line$(10, name$)
 PRINT line$(11, "of")
 PRINT line$(12, company$)
 PRINT line$(14, "Internet:")
 PRINT line$(15, email$)
 PRINT line$(16, url$)
 PRINT line$(20, other$)
END SUB

FUNCTION tri (x)
'This calculates triangular numbers
'Written by:  David Stinemetze
 PRINT x * (x + 1) / 2
 tri = (x * (x + 1) / 2)
END FUNCTION

SUB word (wordval$)
'This sub converts inputed word to ASCII then adds the values together
'Written by:  David Stinemetze
DIM letter(1 TO LEN(wordval$))
 PRINT "Your word in ascii is..."
 wordval = LEN(wordval$)
 FOR k = 1 TO wordval
  letter(k) = ASC(MID$(wordval$, k, 1))
  PRINT letter(k);
  total = total + letter(k)
 NEXT
 PRINT
 PRINT "     ASCII SUM ="; total
END SUB

FUNCTION xroot (x!, rad!)
' This function solves the xroot, of inputed numbers.  x is the value out
' side the radical, and rad is inside the radical
' Written by:  David Stinemetze
 xroot = rad ^ (1 / x)
END FUNCTION

 FUNCTION yx$ (y, x)
 'Calculates y^x in scientific notation
 'Written by:  David Stinemetze
 y = ABS(y)
 SELECT CASE y
  CASE 0
   yx$ = STR$(0) + " * 10 ^ 0"
  CASE ELSE
   yx$ = STR$(10 ^ ABS(INT(Log10(y) * x) - Log10(y) * x)) + " * 10 ^" + STR$(INT(Log10(y) * x))
 END SELECT
END FUNCTION

